clear
clc
close all

N=50;
c=5;
Zeta=0.1;
m1=1;
m2=-1;
s=0.5;
rng('default')
mindex=0;
Is=1;

for Im=0:0.5:1.5
    mindex=mindex+1;
    index=0;
    
    for i=1:5
        [Lambdamu,Lambdasig,Importance]=CreateLambdaFixed(N,m1,m2,Im,Is,s);
        d=0;
        while sum(Lambdamu)>0 || isempty(find(Lambdamu<0))
            [Lambdamu,Lambdasig,Importance]=CreateLambdaFixed(N,m1,m2,Im,Is,s);
            d=d+1;
            if d>1000
                disp('while took too long')
                break
            end
        end
        
        index=index+1;
        [G]=CreateRandRegGraph(N,c);
        [Links]=FixLinks(G,N);
        
        [Satisfied,Edges]=QuenchedLS2(Lambdamu,Lambdasig,Links,Importance,Zeta);
        e=0;
        while sum(Edges(:,3)+Edges(:,4))>0.1
            [Lambdamu,Lambdasig,Importance]=CreateLambdaFixed(N,m1,m2,Im,Is,s);
            d=0;
            while sum(Lambdamu)>0 || isempty(find(Lambdamu<0))
                [Lambdamu,Lambdasig,Importance]=CreateLambdaFixed(N,m1,m2,Im,Is,s);
                d=d+1;
                if d>1000
                    disp('while took too long')
                    break
                end
            end
            
            index=index+1;
            [G]=CreateRandRegGraph(N,c);
            [Links]=FixLinks(G,N);
            
            [Satisfied,Edges]=QuenchedLS2(Lambdamu,Lambdasig,Links,Importance,Zeta);
            
            e=e+1;
            if e>100
                break
            end
        end
        
        PowerLoss(index,mindex)=sum(Edges(:,3).^2)/2;
        ZerY(index,mindex)=sum(Edges(:,3)==0);
        DistY(:,index,mindex)=abs(Edges(:,3));
        Excess(:,index,mindex)=Satisfied;
        Sig(:,index,mindex)=Importance;
        
        
    end
    MM(mindex)=Im;
end

save('AvTest.mat')
% 
% quit
% exit

% figure(5)
% hold on
% DastY=DistY(:,:,1);
% DustY=DastY(:);
% DastY2=DistY(:,:,2);
% DustY2=DastY2(:);
% DastY3=DistY(:,:,3);
% DustY3=DastY3(:);
% % DastY4=DistY(:,:,5);
% % DustY4=DastY4(:);
% a=[0:0.04:max(max(max(DistY)))];
% histogram(DustY(DustY~=0),a);
% histogram(DustY2(DustY2~=0),a);
% histogram(DustY3(DustY3~=0),a);
% % histogram(DustY4(DustY4~=0),a);
% 
% figure(6)
% y=[0:0.005:max(max(max(DistY)))];
% P1=mean(DustY);
% P1s=std(DustY);
% f1=exp(-(y-P1).^2./(2*P1s^2))./(P1s*sqrt(2*pi));
% P2=mean(DustY2);
% P2s=std(DustY2);
% f2=exp(-(y-P2).^2./(2*P2s^2))./(P2s*sqrt(2*pi));
% P3=mean(DustY3);
% P3s=std(DustY3);
% f3=exp(-(y-P3).^2./(2*P3s^2))./(P3s*sqrt(2*pi));
% % P4=mean(DustY4);
% % P4s=std(DustY4);
% % f4=exp(-(y-P4).^2./(2*P4s^2))./(P4s*sqrt(2*pi));
% hold on
% subplot(4,1,1)
% histogram(DustY,a);
% hold on
% plot(y,f1,'-');
% subplot(4,1,2)
% histogram(DustY2,a);
% hold on
% plot(y,f2,'-');
% subplot(4,1,3)
% histogram(DustY3,a);
% hold on
% plot(y,f3,'-');
% % subplot(4,1,4)
% % histogram(DustY4,a);
% % hold on
% % plot(y,f4,'-');
% 
% figure(7)
% hold on
% plot(y,f1,'-');
% plot(y,f2,'-');
% plot(y,f3,'-');
% % plot(y,f4,'-');
% 
figure(8)
Extra=Excess(:,:,1);
Excel=Extra(:);
Extra2=Excess(:,:,2);
Excel2=Extra2(:);
Extra3=Excess(:,:,3);
Excel3=Extra3(:);
Extra4=Excess(:,:,4);
Excel4=Extra4(:);
Sif=Sig(:,:,1);
Sid=Sif(:);
Sif2=Sig(:,:,2);
Sid2=Sif2(:);
Sif3=Sig(:,:,3);
Sid3=Sif3(:);
Sif4=Sig(:,:,4);
Sid4=Sif4(:);
plot(Sid,Excel,'x');
hold on
plot(Sid2,Excel2,'x');
plot(Sid3,Excel3,'x');
plot(Sid4,Excel4,'x');
